#ifndef IKD_OX_BASIC_OXMULTIMAP_H
#define IKD_OX_BASIC_OXMULTIMAP_H

// }`}bvNX
//
//  }`}bvNXłByANXɒ`Ă܂B
//  }`}bvNX͓̃C^[tFCXĂāA}yPCu
//  ׂẴ}bv͂̃NXgpĂ܂B
//  WindowsvbgtH[ȂSTL::multiimapŏ\̂߁AłSTLmultimapbvĂ܂A
//  STLgȂCuŗLmltimapꍇ́A̗ɂȂăC^[tFCXۂ
//  ΑΉł͂łB

#ifdef WIN32
#	include <map>
#endif

namespace OX {
	// yANX
	//  C++STL̃Ce[^bvłB
	//  \bhł΂̃NX̗ɂȂČŗLCudlɒuł܂
	template<class Key, class Val>
	class MPair {
		template<class Key, class Val> friend class MultiMap;
		typename std::multimap<Key, Val>::iterator it;
		std::multimap<Key, Val> &multimap;

		// RXgN^
		//  ̃RXgN^MultiMapNXɂ̂݌JĂ܂
		MPair(std::multimap<Key, Val> &multimap) : multimap(multimap), it(multimap.begin()) {}
		MPair(std::multimap<Key, Val> &multimap, typename std::multimap<Key, Val>::iterator &it) : multimap(multimap), it(it) {}

	public:
		// I[ɒBH
		bool isEnd() {
			return it == multimap.end();
		}
		// ̃Ce[^
		MPair &next() {
			it++;
			return *this;
		}
		// first
		//  Key̒l͕ύXƋ̂ŒlԂ
		Key first() {
			return it->first;
		}

		// second
		//  Val͒ułOKȂ̂ŎQƕԂ
		Val &second() {
			return it->second;
		}

		// 폜
		void remove() {
			if (!isEnd())
				it = map.erase(it);
		}
	};

	// }bvNX
	//  C++STL̃Ce[^bvłB
	//  ŗLCuɑΉɂ́A\bhƋ@\NXŉ̎㏑܂B
	template<class Key, class Val>
	class MultiMap {
		std::multimap<Key, Val> multimap_;

	public:
		// JnyA擾
		MPair<Key, Val> begin() {
			return MPair<Key, Val>(multimap_);
		}
		// 
		MPair<Key, Val> find(Key &key) {
			return MPair<Key, Val>(multimap_, multimap_.find(key));
		}
		MPair<Key, Val> find(const Key &key) {
			return MPair<Key, Val>(multimap_, multimap_.find(key));
		}
		// o^
		void insert(const Key &key, const Val &val) {
			multimap_.insert(std::pair<Key, Val>(key, val));
		}
		void insert(Key &key, const Val &val) {
			multimap_.insert(std::pair<Key, Val>(key, val));
		}
		Val &operator[](const Key &key) {
			MPair<Key, Val> pair = find(key);
			if (pair.isEnd()) {
				insert(key, Val());
				MPair<Key, Val> pair = find(key);
				return pair.second();
			}
			return pair.second();
		}
		Val &operator[](Key &key) {
			MPair<Key, Val> pair = find(key);
			if (pair.isEnd()) {
				insert(key, Val());
				MPair<Key, Val> pair = find(key);
				return pair.second();
			}
			return pair.second();
		}
		// 폜
		void remove(Key &key) {
			multimap_.erase(key);
		}
		void remove(const Key &key) {
			multimap_.erase(key);
		}
		// TCY
		unsigned size() {
			return (unsigned)multimap_.size();
		}
		// NA
		void clear() {
			multimap_.clear();
		}
	};
}

#endif