#ifndef IKD_OX_TEST_TESTLAYOUT_H
#define IKD_OX_TEST_TESTLAYOUT_H

#include "../basic/oxlayout.h"

namespace OX {
	namespace Layout {
		class TurnRedObject : public Object {
			// ҋ@Xe[g
			class IdleState : public State {
				friend Object;

				bool bClicked;

			protected:
				IdleState() : bClicked() {}

			public:
				virtual ~IdleState() {}
				virtual void initialize(Object &env);
				virtual State *update(Object &env, unsigned advance);
				virtual void mouseAction(Object &env, Mouse &mouse);
			};

			// Ɖ]Xe[g
			class RotateState : public State {
				friend Object;

				unsigned curTime, rotTime;

			protected:
				RotateState() : curTime(), rotTime(150) {}

			public:
				virtual ~RotateState() {}
				virtual void initialize(Object &env);
				virtual State *update(Object &env, unsigned advance);
			};

		public:
			// 
			virtual void initialize();

			// }EXANV
			virtual void mouseAction(Mouse &mouse);

		public:
			TurnRedObject();
			virtual ~TurnRedObject();
		};
	}
}
#endif
